#    AWSTrial, A mechanism and service for offering a cloud image trial
#
#    Copyright (C) 2010  Scott Moser <smoser@ubuntu.com>
#    Copyright (C) 2010  Dave Walker (Daviey) <DaveWalker@ubuntu.com>
#    Copyright (C) 2010  Michael Hall <mhall119@gmail.com>
#    Copyright (C) 2010  Dustin Kirkland <kirkland@ubuntu.com>
#    Copyright (C) 2010  Andreas Hasenack <andreas@canonical.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


from django.conf.urls.defaults import *
from django.conf import settings
import ubuntu_website


from django.contrib import admin
admin.autodiscover()


urlpatterns = patterns('',
    (r'^$', 'trial.views.index'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/running/', 'trial.views.reserved_instance'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/start/', 'trial.views.start'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/run/', 'trial.views.run_instance'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/instance_info/', 'trial.views.info_instance'),
    (r'^nxs/(?P<username>[a-zA-Z0-9]+)/(?P<instance_id>i-[a-zA-Z0-9]+)/', 'trial.views.nxs'),
    (r'^istatus/(?P<username>[a-zA-Z0-9]+)/(?P<instance_id>i-[a-zA-Z0-9]+)/(?P<info>[a-z]+)','trial.views.istatus'),

    (r'^feedback/', 'trial.views.feedback'),
    
    (r'^admin/', include(admin.site.urls)),
    (r'^openid/', include('django_openid_auth.urls')),
     (r'^logout/$', 'trial.views.logout_view'),

    (r'^info_callback/(?P<secret>[a-zA-Z0-9]+)/(?P<mode>[a-zA-Z0-9]+)/','trial.info_callback.info_callback'),
    (r'^faq/', 'django.views.generic.simple.direct_to_template', {'template': 'faq.html'}),
    (r'^account-problem/', 'django.views.generic.simple.direct_to_template', {'template': 'account-problem.html'}),
)

if settings.STATIC_SERVE:
    urlpatterns += patterns('',
        (r'^[/]*media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^(robots.txt)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^ubuntu_website/media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': ubuntu_website.MEDIA_ROOT}),
       
    )

